﻿package widget
{
	import flash.display.*;
	import flash.events.*;
	import flash.geom.*;
	import flash.net.URLRequest;
	import flash.system.*;
	
	import gs.TweenMax;
	
	import widget.transitions.*;
	import widget.OpenSocialPhotoLoader;
	
	public class Widget extends MovieClip
	{
		private var myProxy:String = "http://85.17.135.135/~gerbster/projects/FlashTutsWidget/proxy.php?url=";
		//private var myProxy:String = "";
		
		private var myOSPL:OpenSocialPhotoLoader;
		private var photoArray:Array;
		
		private var myPhotoLoader:Loader;
		public var myPhotoHolder:MovieClip;
		
		private var fadeInOutTransition:FadeInOut;
		private var cubes3DTransition:Cubes3D;
		private var transitionsArray:Array = new Array();
		
		private var currentPhotoIndex:Number = 0;
		private var transitionIndex:Number = NaN;
		
		private var photoTime:Number = 5;
		
		public function Widget():void
		{
			Security.allowDomain("orkut.com");
			
			myPhotoHolder = new MovieClip();
			myPhotoHolder.name = "photoHolder";
			
			addChild(myPhotoHolder);
			
			initPhotoArray();
			initTransitions();
			
			if(photoArray.length > 0)
			{
				loadPhoto(currentPhotoIndex);
			}
		}

		private function initPhotoArray()
		{
			myOSPL = new OpenSocialPhotoLoader();
			
			addChild(myOSPL);
			
			myOSPL.loadAlbum();
			
			photoArray = myOSPL.masterAlbum;
		}
		
		private function initTransitions()
		{
			fadeInOutTransition = new FadeInOut();
			cubes3DTransition = new Cubes3D();
			
			transitionsArray.push(fadeInOutTransition);
			transitionsArray.push(cubes3DTransition);
		}

		private function loadPhoto(index:Number):void
		{
			if(index >= photoArray.length)
			{
				index = 0;
			}
			
			if(index == -1)
			{
				index = photoArray.length;
			}
			
			myPhotoLoader = new Loader();
			var photoUrl:String = photoArray[index];
			var photoUrlReq:URLRequest = new URLRequest(myProxy + photoUrl);
			
			myPhotoLoader.load(photoUrlReq);
			
			// if the photo is loaded, call showNextPhoto which will do the transition
			myPhotoLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, showNextPhoto);

			// increment currentPhotoIndex and call this function again in 5 seconds
			currentPhotoIndex = ++index;
			TweenMax.delayedCall( photoTime, loadPhoto, [currentPhotoIndex]);
		}
		
		private function showNextPhoto(e:Event)
		{
			// we want our photo's nicely scaled and centered
			var scaleValue:Number = calculateScaleValue(e.target.loader.contentLoaderInfo.width, e.target.loader.contentLoaderInfo.height);
			
			var translateX:Number = (stage.stageWidth - (e.target.loader.contentLoaderInfo.width * scaleValue)) / 2;
			var translateY:Number = (stage.stageHeight - (e.target.loader.contentLoaderInfo.height * scaleValue)) / 2;
			
			// ...so we use a matrix
			var resizeMatrix:Matrix = new Matrix();
			resizeMatrix.scale(scaleValue, scaleValue);
			resizeMatrix.translate(translateX, translateY);
			
			var newPhotoBitmapData:BitmapData = new BitmapData(stage.stageWidth, stage.stageHeight, false, 0x000000);
			newPhotoBitmapData.draw(e.target.loader, resizeMatrix, null, null, null, true);

			// if there's a photo on stage do a transition
			if(myPhotoHolder.numChildren > 0)
			{
				var oldPhotoBitmapData:BitmapData = new BitmapData(stage.stageWidth, stage.stageHeight, false, 0x000000);
				
				oldPhotoBitmapData.draw(myPhotoHolder.getChildAt(0), null, null, null, null, true);
				
				// remove the old transition object
				if(myPhotoHolder.getChildAt(0) is ITransition)
				{
					transitionsArray[transitionIndex].destroyTransition();
				}
				
				// remove the old transition object
				myPhotoHolder.removeChild(myPhotoHolder.getChildAt(0));
				
				// pick a random transition
				transitionIndex = Math.round(Math.random() * (transitionsArray.length - 1));
				
				myPhotoHolder.addChild(transitionsArray[transitionIndex]);
				
				transitionsArray[transitionIndex].doTransition(oldPhotoBitmapData, newPhotoBitmapData);
			}
			else
			{
				var newPhoto:Bitmap = new Bitmap(newPhotoBitmapData);
				
				myPhotoHolder.addChildAt(newPhoto, 0);
			}
		}
		
		private function calculateScaleValue(oldWidth:Number, oldHeight:Number):Number
		{
			var photoRatio:Number = oldHeight / oldWidth;
			var screenRatio:Number = stage.stageHeight / stage.stageWidth;
			
			if(photoRatio < screenRatio)
			{
				return stage.stageWidth / oldWidth;
			}
			else
			{
				return stage.stageHeight / oldHeight;
			}
		}
	}
}